// Global Variables
var tickinterval;
var time;

// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load(){
    setupParts();
	clearInterval(tickinterval);
	tickinterval = null;
	time = 0;
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync(){

}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove(){
	clearInterval(tickinterval);
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide(){

}

//
// Function: show()
// Called when the widget has been shown
//
function show(){
    // Restart any timers that were stopped on hide
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event){
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event){
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function setTimer(dec){
	time = (dec * 43200).toFixed(0);
	var hours = Math.floor(time / 3600);
	var minutes = Math.floor((time % 3600) / 60);
	var seconds = Math.floor((time % 3600) % 60);
	$("txt-seconds").innerHTML = doubleDigits(seconds);
	$("txt-minutes").innerHTML = doubleDigits(minutes);
	$("txt-hours").innerHTML = doubleDigits(hours);
}

function startTimer(){
	if (tickinterval != null){
		clearInterval(tickinterval);
		tickinterval = null;
		$("button-start").style.visibility = "visible";
		$("button-stop").style.visibility = "hidden";
		setTitle("iTunes Timer");
	}else{
		tickinterval = setInterval("tick()",1000);
		$("button-stop").style.visibility = "visible";
		$("button-start").style.visibility = "hidden";
		setTitle("Time Remaining");
	}
}

function tick(){
	if (time > 0){
		time = (time - 1);
		var hours = Math.floor(time / 3600);
		var minutes = Math.floor((time % 3600) / 60);
		var seconds = Math.floor((time % 3600) % 60);
	
		$("txt-seconds").innerHTML = doubleDigits(seconds);
		$("txt-minutes").innerHTML = doubleDigits(minutes);
		$("txt-hours").innerHTML = doubleDigits(hours);
	}else{
		clearInterval(tickinterval);
		tickinterval = null;
		$("button-start").style.visibility = "visible";
		$("button-stop").style.visibility = "hidden";
		timeReached();
	}
}

function timeReached(){
	if (action() == "play"){
		widget.system("/usr/bin/osascript -e 'tell application \"iTunes\" to play'" , setTitle('iTunes Playing'));
	}else if (action() == "sleep"){
		widget.system("/usr/bin/osascript -e 'tell application \"System Events\" to sleep'", setTitle('Sleeping Now'));
	}else{
		widget.system("/usr/bin/osascript -e 'tell application \"iTunes\" to pause'" , setTitle('iTunes Paused'));
	}
}

function doubleDigits(number)
{
    var digits = number.toString(10);
    if (digits.length == 1) {
        digits = "0" + digits;
    }
    return digits;
}

function action(){
	return $("action-popup").object.getValue();
}

function $(id) {
	return document.getElementById(id);
}

function setTitle(message){
	//$("widgettitle").innerHTML = message;
}
function openURL(){
	widget.openURL('http://studentwebs.winona.edu/mahansen2573')
}